<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 29.70</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onLoadPaging()">
    <div class="container jumbotron">
        <h2 class="text-center">Danh sách người dùng đăng ký</h2>
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users";
        const gEND_OF_ROW_COL = -1;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //Hàm xử lý sự kiện loading
        function onLoadPaging() {
            "use strict";
            //Gọi server
            var vXHTMLRequest = new XMLHttpRequest();
            callApiGetUsers(vXHTMLRequest);
            vXHTMLRequest.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    //Xử lý hiển thị
                    showDataOnTable(vXHTMLRequest);
                    //gán sự kiện click cho nút chi tiết
                    addListonerEventInfoButton();
                }
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm xử lý gọi api send request
        function callApiGetUsers(paramXmlHttp) {
            "use strict";
            paramXmlHttp.open("GET", gBASE_URL, true);
            paramXmlHttp.send();
        }
        //load dữ liệu từ response server trả về vào table, hiện các button chi tiêt
        //input/start:
        //-paramXmlHttpUser: request đã dùng gọi server, và có responseText chứa dữ liệu
        //output/end:
        // - dữ liệu hiển thị trên bảng
        // - các button chi tiết được hiển thị và có sẵn dữ liệu dataset
        function showDataOnTable(paramXmlHttpUser) {
            "use strict";
            console.log(paramXmlHttpUser.responseText)
            //Chuyển json sang object
            var vResponse = JSON.parse(paramXmlHttpUser.responseText);
            var vTable = document.getElementById("user-table");
            var vTableBody = vTable.getElementsByTagName("tbody")[0];

            for (var bIndex = 0; bIndex < vResponse.length; bIndex++) {
                // tạo dòng mưới cho bẳng và ghi vào các giá trị 
                var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
                var vCellUserId = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellFirstname = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellLastname = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCountry = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellSubject = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCustomerType = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellRegisterStatus = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellUserAction = vNewRow.insertCell(gEND_OF_ROW_COL);

                vCellUserId.innerHTML = vResponse[bIndex].id;
                vCellFirstname.innerHTML = vResponse[bIndex].firstname;
                vCellLastname.innerHTML = vResponse[bIndex].lastname;
                vCellCountry.innerHTML = vResponse[bIndex].country;
                vCellSubject.innerHTML = vResponse[bIndex].subject;
                vCellCustomerType.innerHTML = vResponse[bIndex].customerType;
                vCellRegisterStatus.innerHTML = vResponse[bIndex].registerStatus;
                
                var vDetailButton = document.createElement("button");
                vDetailButton.innerHTML = "Chi tiết";
                vDetailButton.className = "info-user btn btn-info";
                vDetailButton.setAttribute("data-id", vResponse[bIndex].id);
                vDetailButton.setAttribute("data-firstname", vResponse[bIndex].firstname);
                vDetailButton.setAttribute("data-lastname", vResponse[bIndex].lastname);
                vDetailButton.setAttribute("data-country", vResponse[bIndex].country);
                vDetailButton.setAttribute("data-subject", vResponse[bIndex].subject);
                vDetailButton.setAttribute("data-customer-type", vResponse[bIndex].customerType);
                vDetailButton.setAttribute("data-register-status", vResponse[bIndex].registerStatus);
                vCellUserAction.appendChild(vDetailButton);
            }
        }

        //Add listner cho event handler (event click chính là onclick)
        //Khi ấn nút sẽ gọi function onBtnChiTietClick
        function  addListonerEventInfoButton() {
            //truy xuất tất cả các nút detail qua className
            var vDetailButtons = document.getElementsByClassName("info-user");
            for (var bIndex = 0; bIndex < vDetailButtons.length; bIndex++) {
                vDetailButtons[bIndex].addEventListener('click', function() {
                    onBtnChiTietClick(this);
                });
            }
        }

        //onBtnChiTietClick
        function onBtnChiTietClick(paramDetailButton){
            //thu thập dữ liệu
            var vUserId = paramDetailButton.dataset.id;
            var vFirstName = paramDetailButton.dataset.firstname;
            var vLastName = paramDetailButton.dataset.lastname;
            var vCountry = paramDetailButton.dataset.country;
            var vSubject = paramDetailButton.dataset.subject;
            var vCustomerType = paramDetailButton.dataset.customerType;
            var vRegisterStatus = paramDetailButton.dataset.registerStatus;
            console.log("Thông tin user");
            console.log("User id: ", vUserId);
            console.log("First name: ", vFirstName);
            console.log("Last name: ", vLastName);
            console.log("Country: ", vCountry);
            console.log("Subject: ", vSubject);
            console.log("Customer Type: ", vCustomerType);
            console.log("User id: ", vRegisterStatus);
            const vDETAIL_FORM_URL = "userdetails.html"
                var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" +
                    "id=" + vUserId +
                    "&firstname=" + vFirstName +
                    "&lastname=" + vLastName +
                    "&country=" + vCountry +
                    "&subject=" + vSubject ;
                window.location.href = vUrlSiteToOpen;
        }
    </script>

</body>

</html>